#include <stdio.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <tcl.h>


extern Function *rl_event_hook;

/* Tcl readline command */
int Rl_ReadlineCmd(ClientData clientData, Tcl_Interp *interp, int objc, 
		   Tcl_Obj *CONST objv[])
{
  Tcl_Obj * resultPtr;
  char *str;

  if(objc > 2) {
    Tcl_WrongNumArgs(interp, 1, objv, "?prompt?");
    return TCL_ERROR;
  }
  
  if (objc==2) {
    str = readline(Tcl_GetStringFromObj(objv[1], NULL));
  } else {
    str = readline("");
  }

  resultPtr = Tcl_GetObjResult(interp);

  if (str==NULL) {
     Tcl_SetStringObj(resultPtr,"readline EOF",-1);
     return TCL_ERROR;
  }

  add_history(str);
  
  Tcl_SetStringObj(resultPtr,str,-1);
  return TCL_OK;
}

/* 
   What should this function be doing to enter the
   Tcl event loop? 
*/
void TclEventLoop() {
  int flags;
  
  flags = TCL_DONT_WAIT;

  /*printf("This is being callled.\n");*/
  
  while (Tcl_DoOneEvent(flags)) {
    /*printf("We never find an event.\n");*/
  }

}

int Tcl_readline_Init(Tcl_Interp *interp) {
 
  /* This is executed continuously, but doesn't seem to do anything... */
  rl_event_hook = (Function *)TclEventLoop;

  Tcl_CreateObjCommand(interp,"readline",Rl_ReadlineCmd,
		       (ClientData)NULL,(Tcl_CmdDeleteProc*)NULL);    
  return TCL_OK;
}
